local assets =
{
    Asset("ANIM", "anim/multitool_axe_pickaxe.zip"),
    Asset("ANIM", "anim/swap_multitool_axe_pickaxe.zip"),
}

local function Emmmm(inst)
    local super_pike = SpawnPrefab("super_pike")
    local container = inst.components.inventoryitem:GetContainer()
    if container ~= nil then
        local slot = inst.components.inventoryitem:GetSlotNum()
        inst:Remove()
        container:GiveItem(super_pike, slot)
    else
        local x, y, z = inst.Transform:GetWorldPosition()
        inst:Remove()
        super_pike.Transform:SetPosition(x, y, z)
    end
end

local function OnGetItemFromPlayer(inst, giver, item, player)
    local currentperc = inst.components.finiteuses:GetPercent()
    if currentperc < 0.001 then
        inst.components.weapon:SetDamage(0)
        inst.components.tool:SetAction(ACTIONS.CHOP, 0)
        inst.components.tool:SetAction(ACTIONS.MINE, 0)
        inst.components.waterproofer:SetEffectiveness(0)
    else
        inst.components.weapon:SetDamage(10 + 25 * inst.orangeCount / TUNING.orange_pike)
        inst.components.tool:SetAction(ACTIONS.CHOP, 1 + 8 * inst.greenCount / TUNING.green_pike)
        inst.components.tool:SetAction(ACTIONS.MINE, 1 + 8 * inst.greenCount / TUNING.green_pike)
        inst.components.waterproofer:SetEffectiveness(0.6 * inst.purpleCount / TUNING.purple_pike)
    end
    if item  then
        inst.SoundEmitter:PlaySound("dontstarve/common/telebase_gemplace")
        if  item.prefab == "greengem" then
            if inst.greenCount < TUNING.green_pike then
                inst.greenCount = inst.greenCount + 1
                inst.components.tool:SetAction(ACTIONS.CHOP, 1 + 8 * inst.greenCount / TUNING.green_pike)
                inst.components.tool:SetAction(ACTIONS.MINE, 1 + 8 * inst.greenCount / TUNING.green_pike)
                giver.components.talker:Say("绿宝石数量:"..inst.greenCount.."/"..TUNING.green_pike.." 效率:"..(1 + 8 * inst.greenCount / TUNING.green_pike).."倍")
            else
                giver.components.talker:Say("绿宝石已满")
            end
        end
        if  item.prefab == "yellowgem" then
            if inst.yellowCount < TUNING.yellow_pike then
                inst.yellowCount = inst.yellowCount + 1
                inst.components.finiteuses:SetMaxUses(300 + 650 * inst.yellowCount / TUNING.yellow_pike)
                giver.components.talker:Say("黄宝石数量:"..inst.yellowCount.."/"..TUNING.yellow_pike)
            else
                giver.components.talker:Say("黄宝石已满")
            end
        end
        if  item.prefab == "orangegem" then
            if inst.orangeCount < TUNING.orange_pike then
                inst.orangeCount = inst.orangeCount + 1
                inst.components.weapon:SetDamage(10 + 25 * inst.orangeCount / TUNING.orange_pike)
                giver.components.talker:Say("橙宝石数量:"..inst.orangeCount.."/"..TUNING.orange_pike)
            else
                giver.components.talker:Say("橙宝石已满")
            end
        end
        if  item.prefab == "purplegem" then
            if inst.purpleCount < TUNING.purple_pike then
                inst.purpleCount = inst.purpleCount + 1
                inst.components.waterproofer:SetEffectiveness(0.6 * inst.purpleCount / TUNING.purple_pike)
                giver.components.talker:Say("紫宝石数量:"..inst.purpleCount.."/"..TUNING.purple_pike)
            else
                giver.components.talker:Say("紫宝石已满")
            end
        end
        if item.prefab == "thulecite" then
            currentperc = currentperc + 0.40
        end
        if item.prefab == "thulecite_pieces" then
            currentperc = currentperc + 0.06
        end
        if item.prefab == "redgem" or  item.prefab == "bluegem" then
            currentperc = currentperc + 0.1
        end
    end
    if currentperc >= 1 then
        currentperc = 1
    end
    inst.components.finiteuses:SetPercent(currentperc)
    if inst.greenCount >= TUNING.green_pike and inst.yellowCount >= TUNING.yellow_pike and inst.orangeCount >= TUNING.orange_pike and inst.purpleCount >= TUNING.purple_pike then
        Emmmm(inst)
    end
end

local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "swap_multitool_axe_pickaxe", "swap_object")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
end

local function onunequip(inst, owner)
    owner.AnimState:Hide("ARM_carry")
    owner.AnimState:Show("ARM_normal")
end

local function onpreload(inst, data)
    if data then
        if data.greenCount then
            inst.greenCount = data.greenCount
        end
        if data.yellowCount then
            inst.yellowCount = data.yellowCount
        end
        if data.orangeCount then
            inst.orangeCount = data.orangeCount
        end
        if data.purpleCount then
            inst.purpleCount = data.purpleCount
        end
        if data.current ~= nil then
            inst.components.finiteuses.current = data.current
        end
        OnGetItemFromPlayer(inst)

        inst.components.weapon:SetDamage(10 + 25 * inst.orangeCount / TUNING.orange_pike)
        inst.components.tool:SetAction(ACTIONS.CHOP, 1 + 8 * inst.greenCount / TUNING.green_pike)
        inst.components.tool:SetAction(ACTIONS.MINE, 1 + 8 * inst.greenCount / TUNING.green_pike)
        inst.components.waterproofer:SetEffectiveness(0.6 * inst.purpleCount / TUNING.purple_pike)

        if inst.greenCount >= TUNING.green_pike and inst.yellowCount >= TUNING.yellow_pike and inst.orangeCount >= TUNING.orange_pike and inst.purpleCount >= TUNING.purple_pike then
            Emmmm(inst)
        else
            inst.components.finiteuses:SetMaxUses(300 + 650 * inst.yellowCount / TUNING.yellow_pike)
        end
    end
end

local function onsave(inst, data)
    data.greenCount = inst.greenCount
    data.yellowCount = inst.yellowCount
    data.orangeCount = inst.orangeCount
    data.purpleCount = inst.purpleCount
    data.current = inst.components.finiteuses.current
end

local function OnRefuseItem(inst, giver, item)
    if item then
        giver.components.talker:Say("镐斧".."\n绿:"..inst.greenCount.."/"..TUNING.green_pike.."\n黄:"..inst.yellowCount.."/"..TUNING.yellow_pike.."\n橙:"..inst.orangeCount.."/"..TUNING.orange_pike.."\n紫:"..inst.purpleCount.."/"..TUNING.purple_pike)
    end
end

local function AcceptTest(inst, item)
    return item.prefab == "greengem" or item.prefab == "yellowgem" or item.prefab == "orangegem" or
    item.prefab == "thulecite" or item.prefab == "thulecite_pieces" or item.prefab == "bluegem"
    or item.prefab == "purplegem" or item.prefab == "redgem"
end

local function onfinished(inst)
    inst.components.weapon:SetDamage(0)
    inst.components.tool:SetAction(ACTIONS.CHOP, 0)
    inst.components.tool:SetAction(ACTIONS.MINE, 0)
    inst.components.waterproofer:SetEffectiveness(0)
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("multitool_axe_pickaxe")
    inst.AnimState:SetBuild("multitool_axe_pickaxe")
    inst.AnimState:PlayAnimation("idle")

    inst:AddTag("sharp")
    inst:AddTag("waterproofer")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst.greenCount = 0
    inst.yellowCount = 0
    inst.orangeCount = 0
    inst.purpleCount = 0
    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(10)
    -----
    inst:AddComponent("tool")
    inst.components.tool:SetAction(ACTIONS.CHOP, 1)
    inst.components.tool:SetAction(ACTIONS.MINE, 1)
    -------
    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(300)
    inst.components.finiteuses:SetUses(300)
    inst.components.finiteuses:SetOnFinished(onfinished)
    inst.components.finiteuses:SetConsumption(ACTIONS.CHOP, 1)
    inst.components.finiteuses:SetConsumption(ACTIONS.MINE, 1)
    -------

    inst:AddComponent("waterproofer")
    inst.components.waterproofer:SetEffectiveness(0)

    inst:AddComponent("inspectable")

    inst:AddComponent("named")
    inst.components.named:SetName("镐斧\n  加入物品强化\n《绿宝石》加效率\n《黄宝石》加耐久\n《橙宝石》加攻击\n《紫宝石》加防水\n《铥矿蓝红宝石》可修复\n其他物品查看属性值")

    inst:AddComponent("inventoryitem")

    inst:AddComponent("equippable")

    inst.components.equippable:SetOnEquip(onequip)

    inst.components.equippable:SetOnUnequip(onunequip)

    inst:AddComponent("trader")
    inst.components.trader:SetAcceptTest(AcceptTest)
    inst.components.trader.onaccept = OnGetItemFromPlayer
    inst.components.trader.onrefuse = OnRefuseItem
    inst.OnSave = onsave
    inst.OnPreLoad = onpreload

    MakeHauntableLaunch(inst)

    return inst
end

return Prefab("multitool_axe_pickaxe", fn, assets)