local assets =
{
    Asset("ANIM", "anim/trident.zip"),
    Asset("ANIM", "anim/swap_trident.zip"),
}

local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "swap_trident", "swap_trident")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
end

local function onunequip(inst, owner)
    owner.AnimState:Hide("ARM_carry")
    owner.AnimState:Show("ARM_normal")
end

local function onattack(inst)
    if inst ~= nil and inst.fire ~= nil and inst:IsValid() and inst.fire:IsValid() then
        local x, y, z = inst.fire.Transform:GetWorldPosition()
        SpawnPrefab("sparks").Transform:SetPosition(x, y - .5, z)
    end
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("trident")
    inst.AnimState:SetBuild("trident")
    inst.AnimState:PlayAnimation("idle")

    inst:AddTag("sharp")
    inst:AddTag("waterproofer")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(36)
    inst.components.weapon:SetOnAttack(onattack)
    inst.components.weapon:SetElectric()
    -----
    inst:AddComponent("tool")
    inst.components.tool:SetAction(ACTIONS.CHOP, 100)
    inst.components.tool:SetAction(ACTIONS.MINE, 100)
    inst.components.tool:SetAction(ACTIONS.HAMMER, 100)
    inst.components.tool:SetAction(ACTIONS.DIG, 100)
    -------

    inst:AddComponent("waterproofer")
    inst.components.waterproofer:SetEffectiveness(0.8)

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/super_pike.xml"

    inst:AddComponent("equippable")
    inst.components.equippable.insulated = true

    inst.components.equippable:SetOnEquip(onequip)

    inst.components.equippable:SetOnUnequip(onunequip)

    MakeHauntableLaunch(inst)

    return inst
end

return Prefab("super_pike", fn, assets)