local assets=
{
    Asset("ATLAS", "images/inventoryimages/cutlass.xml"),
    Asset("IMAGE", "images/inventoryimages/cutlass.tex"),
	Asset("ANIM", "anim/cutlass.zip"),
	Asset("ANIM", "anim/swap_cutlass.zip"),
}

local function onequip(inst, owner) 
    owner.AnimState:OverrideSymbol("swap_object", "swap_cutlass", "swap_cutlass")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
end

local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end

local function onattack(inst, attacker, target)
    if target and target.components.freezable and math.random() < 0.75 then
        target.components.freezable:AddColdness(0.6)
        target.components.freezable:SpawnShatterFX()
        local prefab = "icespike_fx_"..math.random(1,4)
        local fx = SpawnPrefab(prefab)
        fx.Transform:SetScale(1, 0.8, 1)
        fx.Transform:SetPosition(target:GetPosition():Get())
    end
    --if target.prefab == "twister" then
    --    target.components.health:DoDelta(-TUNING.CUTLASS_BONUS_DAMAGE)
    --end
end

local function fn(Sim)
	local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()
    
    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("cutlass")
    inst.AnimState:SetBuild("cutlass")
    inst.AnimState:PlayAnimation("idle")
    
    inst:AddTag("sharp")
    inst:AddTag("cutlass")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(80)
    inst.components.weapon:SetOnAttack(onattack)

    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/cutlass.xml"
    
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
    
    return inst
end

return Prefab( "cutlass", fn, assets)
